from flask import Flask, request, render_template
from rq import Queue
from redis import Redis
import subprocess

app = Flask(__name__)

# Configuration Redis et file d'attente
redis_conn = Redis()
queue = Queue(connection=redis_conn)

@app.route('/')
def index():
    return render_template('index.html')

@app.route('/scraper', methods=['POST'])
def scraper():
    site_url = request.form.get('site_url')
    if not site_url:
        return "URL manquante", 400

    # Ajouter la tâche à la file d'attente
    queue.enqueue(run_scraper, site_url)
    return f"<h1>Scraping lancé</h1><p>Les images seront téléchargées dans le dossier <a href='/incoming'>FTP</a>.</p>"

def run_scraper(site_url):
    subprocess.run(['scrapy', 'crawl', 'imagespider', '-a', f'start_url={site_url}', '-a', f'output_dir=/home/noenaturegroup/public_ftp/incoming'])

if __name__ == "__main__":
    app.run(debug=True)
